//! This software aim at helping you generate comic book archive. You can use it to generate comic
//! book archive, or just making sure your list of files will be ordered the same way on any
//! operating system.

use cbb;
use cbb::ComicBook;
use cbb::Opt;

use std::env;
use std::fs;

fn main() {
    let opt = Opt::new(env::args());
    dbg!(&opt);

    // if opt.recursive
    // /*|| opt.prefix*/
    // {
    //     unimplemented!();
    // }

    env::set_current_dir(opt.comic_folder).unwrap();
    let mut book = ComicBook::new(fs::read_dir(".").unwrap(), opt.pad);

    let bind_func = if opt.dry_run { dry_run } else { rename };
    book.bind(bind_func);
}

fn dry_run(original: String, new: String) {
    // TODO: Is it possible to be certain that the alignment is kept (like in a table)?
    // I think there is at least a crate doing that. But I do not want to add bloat only for this
    // => To benchmark (binary size, clean compile)
    println!("{}\t-> {}", original, new);
}

fn rename(original: String, new: String) {
    fs::rename(original, new).expect("RENAME FAILED");
}
